<?php
	/*
	* 2018 - VEGA Informatique
	*
	* NOTICE OF LICENSE
	*
	* This source file is subject to the Open Software License (OSL 3.0)
	* that is bundled with this package in the file LICENSE.txt.
	* It is also available through the world-wide-web at this URL:
	* http://opensource.org/licenses/osl-3.0.php
	*
	* DISCLAIMER
	*
	* Do not edit or add to this file if you wish to upgrade PolarisLink to newer
	* versions in the future. 
	*
	*  @author VEGA Informatique <contact@vega-info.fr>
	*  @copyright  2018 VEGA Informatique
	*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
	*/

if (!defined('_PS_VERSION_'))
  exit;

require_once(_PS_ROOT_DIR_ . "/modules/polarislink/classes/VegaAutoUpdate.php");

class AdminPolarisLinkVegaAutoUpdaterController extends ModuleAdminController
{	
	public function __construct()
	{
		$this->context = Context::getContext();			
		$this->bootstrap = true;
					
		parent::__construct();		
	}
	
	
	
	/* On procède à l'affichage */
	public function renderList()
	{		
		$updater = new VegaAutoUpdate($this->module);

		$output = "";
		
		try
		{
			// Si on a demandé un upgrade, alors on applique la mise à jour
			if (isset($_REQUEST["upgradeFrom"]) && !empty($_REQUEST["upgradeFrom"]))
			{
				$updater->doUpgrade($_REQUEST["upgradeFrom"]);
				return '<div class="alert alert-info">'."Votre module a été mis à jour !".'</div>'.
						'<div>[ <a href="'.$this->context->link->getAdminLink("AdminModules") . '&configure=polarislink&tab_module=administration&module_name=polarislink">Retourner à la configuration du module</a> ]</div>';;
			}

			// Ok, on se trouve ici, on cherche à télécharger et installer les binaires de la mises à jour

			if (version_compare(phpversion(), "7.0") < 0)
				$output .= '<div class="alert alert-danger"><strong>Pour des raisons de sécurité, votre version de PHP n\'est plus supportée par notre passerelle.</strong>'.
						'<hr>'.
						'Pour mettre à jour cette dernière et profiter des nouvelles fonctionnalités et corrections, vous devez installer PHP 7.0 au minimum, version compatible avec votre version de Prestashop !</div>';

			PrestaShopLogger::addLog("Demande de recherche de mise à jour ...", 1, 1, $this->module->displayName, 1, true);
			if ($updater->doUpdates())			
			{
				$output .= '<div class="alert alert-info">'."La mise à jour a été téléchargée et va être installée !".'</div>';
				Tools::redirect($this->context->link->getAdminLink('AdminPolarisLinkVegaAutoUpdater', true, array(), array('upgradeFrom' => $this->module->version)));
			}
			else
			{
				$output .= '<div class="alert alert-success">'."Votre module de synchronisation est à jour !".'</div>';			
				$output .= '<div>[ <a href="'.$this->context->link->getAdminLink("AdminModules") . '&configure=polarislink&tab_module=administration&module_name=polarislink">Retourner à la configuration du module</a> ]</div>';
			}
		}
		catch (Exception $ex)
		{
			PrestaShopLogger::addLog("Erreur lors de la mise à jour : ".$ex->getMessage(), 2, 1, $this->module->displayName, 1, true);
			$output .= '<div class="alert alert-danger">'.Tools::displayError($ex->getMessage()).'</div>';
		}
		
		return $output;
	}
}